#
# Default settings
# See the Getting Started Guide for details
#
# The dictionary MUST be called "defaults" - do not change the name
# The defaults dictionary MUST contain default values for all settings
# The value of a setting may be changed but do NOT delete any of the settings
#


defaults = {
	'InstrIp':	 			'192.168.3.100',
	'GuiIp':				'localhost',
	'GuiPort':				9000,
	'Type': 				'PTP-BOTH',
	'PtpPoints':			["0","1","2","3","4","5","6","7","8","9"],
	'SyncEPoints':			["0","1","2","3","4","5","6","7","8","9","10","11"],
	'CableDelay': 			5,
	'LineRate': 			'1GBE',
	'Interface': 			'ELECTRICAL',
	'Reference': 			'INT',
	'TwoStep':				'FALSE',
	'SettlingTime': 		120,
	'RecoveryTime': 		50,
	'1ppsThreshold': 		1.0,
	'1ppsImpedance':		'R50',
	'LimitsEnabled':		'TRUE',
	'AutoNegotiate': 		'FALSE',
	'SyncE': 				'TRUE',
	'RemoteCaptureFolder':	'C:/Desktop',
	'RemoteProfileFolder':	'C:/Desktop',
	'Debug': 				'FALSE',
	'ReProcess':			'FALSE',
	'Filter':				'LSQ',
	'SimulatedData': 		'FALSE',
	'Graphing':      		'FALSE',
	'GraphingYAxis':		'GAIN',
	'MasterMcastAddress': 	'FORWARDABLE',
	'SlaveMcastAddress': 	'FORWARDABLE'
}
