import results
from results import *
import paragonwl
import Commonfunctions

revisit = 0


class MeasurementAnalysis:
    
    def __init__ (self, paragonObject1):
        self.paragonObject = paragonObject1
        self.result = 0

    #def __del__():
    
    
    def getResult ():
        return ( self.result )
    
    
    def createResult ( self,measurementAnalysis,  timeMeasurement ):
 
        if timeMeasurement == "2Way" :
            self.result =  ResultSet1 (self.paragonObject, measurementAnalysis , timeMeasurement )
        elif  timeMeasurement == "1pps" :
            self.result = ResultSet1 (self.paragonObject, measurementAnalysis , timeMeasurement )
        else:
            self.result = ResultSet2 (self.paragonObject, measurementAnalysis , timeMeasurement )
        
        return (self.result)
    
    
    def selectSlot ( self,timeMeasurement ):
 
        self.paragonObject.paragonset("Cat SelectSlot",  timeMeasurement)
        self.paragonObject.paragonset("Cat EnabledSlot", "True")
    
    
    def enableMeasurement ( self,measurementAnalysis ):
        self.paragonObject.paragonset( "Cat %s Enable" % measurementAnalysis, "TRUE")
    
    


        #   =================================================================================================


class TransparentClockAccuracyMeasurementAnalysis( MeasurementAnalysis):

    ##############################
    # DJWAT REVISIT
    # constructor { paragonObject1 } {
    #    next $paragonObject1 

    
    
    def __init__(self, paragonObject1):
        self.paragonObject = paragonObject1
        super().__init__(paragonObject1)

    #def __del__():        
    


    # =================================================================================================


class TimeErrorMeasurementAnalysis (MeasurementAnalysis):
    global paragonObject
    global timeMeasurement 
    global limitEnable 
    limitEnable = None
    global limitValue 
    limitValue = None
    

    

    ##############################
    # DJWAT REVISIT
    # constructor { paragonObject1 } {
    #     next $paragonObject1 
    

    def __init(self,paragonObject1,timeMeasurement):
        self.paragonObject = paragonObject1
        self.timeMeasurement = timeMeasurement
        super().__init__(paragonObject1)

    
    #def __del__():
    
    

    def errorCheckIncludeCorrectionField(self):
        if self.timeMeasurement == "1pps":
            error (" Error: Include Correction Field configuration is not avaliable for %s" % timeMeasurement )            
        
    
    
    
    def createResult (self,measurementAnalysis):
        

        revisit = 1
        # ##########################
        #  DJWAT REVISIT
        # ##########################
        # next $measurementAnalysis $timeMeasurement       
        return(super().createResult( measurementAnalysis,self.timeMeasurement))
       
    
    def getTimeMeasurement (self):

        return (self.timeMeasurement)

    
    
    def setLimitEnable ( self,measurementAnalysis, value ):
        super().selectSlot (self.__format__timeMeasurement)
        self.paragonObject.paragonset( "Cat %s ThresholdLimitEnabled" % measurementAnalysis , str(value))
        self.limitEnable = value
    
    
    def  getLimitEnable ( self,measurementAnalysis ):
        super().selectSlot (self.timeMeasurement)
    
        if self.limit != None:
            return (self.limitValue)
        else:
            self.limitEnable = self.paragonObject.paragonget("Cat %s ThresholdLimitEnabled"  % measurementAnalysis )
            return (self.limitEnable)
        
    
    
    def setLimitValue ( self,measurementAnalysis, value ):
        super().selectSlot (self.timeMeasurement)
        self.paragonObject.paragonset ("Cat %s  ThresholdLimit" % measurementAnalysis, str (value))
        self.limitValue = value
    
       
       
    def getLimitValue ( self,measurementAnalysis ):
        super().selectSlot (self.timeMeasurement)
        if  self.limitValue != None:
            return (self.limitValue)
        else:
            self.limitValue = self.paragonObject.paragonget( "Cat %s ThresholdLimit" %measurementAnalysis)
            return (self.limitValue)
        
    # =================================================================================================

class TETCMeasurementAnalysis ( TransparentClockAccuracyMeasurementAnalysis ):
    global paragonObject
    global timeMeasurement    
    timeMeasurement     = None
    global measurementAnalysis
    measurementAnalysis = None
    global  measurementAnalysisList 
    measurementAnalysisList  = None

    
    def __init__ (self,  paragonObject1, timeMeasurement1):
        ####################################
        # DJWAT REVISIT
        ####################################
        #         next $paragonObject
        super().__init__(paragonObject1)
        self.timeMeasurement = timeMeasurement1
    
    
    #def __del__():      
    
    
    
    def errorCheckMeasurementAnalysis(self):
        
        if self.measurementAnalysis == None:
            error (" Error: Measurement analysis was not defined ")
        
    
    
    
    def createResult(self):
        ####################################
        # DJWAT REVISIT
        ####################################
        #       next $measurementAnalysis $timeMeasurement
        return (super().createResult(  self.measurementAnalysis, self.timeMeasurement))
        revisit = 1
    
    
    def getTimeMeasurement (self):
        
        return (self.timeMeasurement)
    
    
    def setMeasurementAnalysis (self, measurementAnalysisType ): 
        
        if measurementAnalysisType in self.measurementAnalysisList:
            if self.timeMeasurement == "Sync":
                self.measurementAnalysis = self.measurementAnalysis + "FWD_" + measurementAnalysisType
            elif self.timeMeasurement == "Delay Req":
                self.measurementAnalysis = self.measurementAnalysis + "REV_" + measurementAnalysisType
            elif timeMeasurement == "2Way" and self.measurementAnalysisType == "CF_ACCURACY":
                self.measurementAnalysis = self.measurementAnalysis + "TWOWAY_" + measurementAnalysisType
            else:
                error (" Error: Incorrect measurement analysis: %s %s" % (self.timeMeasurement,measurementAnalysisType))
                
            MeasurementAnalysis.enableMeasurement (self.measurementAnalysis)
                        
        else:
            error (" Error: Incorrect measurement analysis: %s, possilbe measurement analysis are %s " % (measurementAnalysisType,self.measurementAnalysisList ))
        
        
    
    
    def getMeasurementAnalysis (self):
        self.errorCheckMeasurementAnalysis()
        return (self.measurementAnalysis)
    
    # =================================================================================================

class TEMeasurementAnalysis (TimeErrorMeasurementAnalysis):
    global paragonObject
    global timeMeasurement
      
    
    def __init__ (self, paragonObject1, timeMeasurement1):
       ###################################
        # DJWAT REVISIT
        # ################################
        # 
        #        next $paragonObject1
        self.timeMeasurement = timeMeasurement1
        self.paragonObject = paragonObject1
        self.result = None
        super().__init__(paragonObject1)
        super().enableMeasurement ("TE")
 
   
    
    #def __del__():
    
    
    def createResult (self):
        ###################################
        # DJWAT REVISIT
        # ################################
        # 
        #      next "TE"
        revisit = 1
        self.result = super().createResult("TE")
        return (self.result)
    
    def errorCheckZero1pps (self):
        if self.timeMeasurement != "1pps":
            error (" Error: Zero1pps configuration is avaliable only for 1pps measurement, not for %s" %timeMeasurement )
        
    
    
    
    def setIncludeCorrectionField ( self,value ):
        super().selectSlot (self.timeMeasurement)
        super().errorCheckIncludeCorrectionField()
        self.paragonObject.paragonset( "Cat TIMEERROR IncludeCorrectionField", str (value))
        self.paragonObject.calculateRequiredSetTrue()
    
    
    def getIncludeCorrectionField (self):
        super().selectSlot (self.timeMeasurement)
        super().errorCheckIncludeCorrectionField()
        return ( paragonObject.paragonget ("Cat TIMEERROR IncludeCorrectionField"))
    
    
    def setZero1pps ( self,value ):
        super().selectSlot (self.timeMeasurement)
        super().errorCheckZero1pps()
        self.paragonObject.paragonset ("Cat TIMEERROR RemoveOffset", str( value))
        self.paragonObject.calculateRequiredSetTrue() ;#  not sure if needed
    
    
    def getZero1pps (self):
        super().selectSlot (timeMeasurement)
        super().errorCheckZero1pps()
        return (self.paragonObject.paragonget ("Cat TIMEERROR RemoveOffset"))
    
    
    
    def setLimitEnable ( self,value ):
        ############################################
        # DJWAT REVISIT
        #        next "TE" $value
        super().setLimitEnable("TE", value)
        revisit = 1   
    
    def getLimitEnable (self):
        ############################################
        # DJWAT REVISIT
        #        next "TE"
        limitEnable = super().getLimitEnable("TE") 
        return (limitEnable)
    
    def setLimitValue ( self,limitValue ):
        ############################################
        # DJWAT REVISIT
        #         next "TE" $limitValue
        limitValue = super().setLimitValue("TE",limitValue)
    
    def getLimitValue (self):

        ############################################
        # DJWAT REVISIT
        #        next "TE"
        revisit = 1
        limitValue = super().getLimitValue("TE")
        return (limitValue)


        # =================================================================================================

class ATEMeasurementAnalysis (TimeErrorMeasurementAnalysis):
    global paragonObject 
    global timeMeasurement    
 
    
    def __init__ (self, paragonObject1, timeMeasurement1):
        ############################################
        # DJWAT REVISIT
        #        next $paragonObject1
        self.paragonObject = paragonObject1
        super().__init__(paragonObject1)
        self.timeMeasurement = timeMeasurement1
        super().enableMeasurement ("ATE")
    
    
    #def __del__():      
    
    
    def createResult (self):
        ############################################
        # DJWAT REVISIT
        #      next "ATE"
        return (super().createResult("ATE"))
        revisit = 1
    
    
    def setIncludeCorrectionField ( self,value ):
        super().selectSlot(self.timeMeasurement)
        super().errorCheckIncludeCorrectionField()
        self.paragonObject.paragonset ("Cat AVERAGEDTE IncludeCorrectionField", str(value))
        self.paragonObject.calculateRequiredSetTrue()

    
    
    def getIncludeCorrectionField (self):
        super().selectSlot (self.timeMeasurement)
        super().errorCheckIncludeCorrectionField()
        return (self.paragonObject.paragonget ("Cat AVERAGEDTE IncludeCorrectionField "))
    
    
    
    def setAveragingPeriod ( self,averagingPeriodValue ):
        super().selectSlot ( self.timeMeasurement)
        self.paragonObject.paragonset ("Cat AVERAGEDTE AveragingPeriod", str ( averagingPeriodValue))
        self.paragonObject.calculateRequiredSetTrue()
    
    
    def getAveragingPeriod (self):
        return ( self.paragonObject.paragonget ("Cat AVERAGEDTE AveragingPeriod")) 
    
    
    def setLimitEnable (self,value):
        ############################################
        # DJWAT REVISIT
        #        next "ATE" $value
        super().setLimitEnable("ATE",value)
        revisit = 1
    
    def getLimitEnable (self):
        ############################################
        # DJWAT REVISIT
        #        next "ATE"
        revisit = 1
        limitEnable = super().getLimitEnable(self.measurementAnalysis)
        
        return (limitEnable)
        
    
    
    def setLimitValue ( self,limitValue ):
        ############################################
        # DJWAT REVISIT
        #        next "ATE" $limitValue
        revisit = 1
        super().setLimitValue(self.measurementAnalysis, limitValue)
    
    
    def getLimitValue (self):
        ############################################
        #  DJWAT REVISIT
        #        next "ATE"
        limitValue = super().getLimitValue(self.measurementAnalysis)
        return (limitValue)
        revisit = 1
    
    


    # =================================================================================================

class  DTELF_HFMeasurementAnalysis (TimeErrorMeasurementAnalysis):
    global  paragonObject 
    global timeMeasurement
    global  filterType
    global measurementAnalysis
     

    
    def __init__ (self, paragonObject1, timeMeasurement1 ):
    ############################################
    # DJWAT REVISIT
    #         next $paragonObject1
        self.paragonObject = paragonObject
        self.timeMeasurement = timeMeasurement1
        super().__init__(self.paragonObject)

        #set filterTypesList { LF HF }
    
    
    #def __del__():    
    

    
    def errorCheckLimitConfigurationAvailability (self):
        
        if (self.timeMeasurement != "2Way") and self.timeMeasurement != "1pps":
            error (" Error: setting Limit is not possible for  %s measurement, only for 2Way and 1pps" % self.timeMeasurement)
        
    
    
    def createResult (self):

        if self.filterType == "LF" :
            self.measurementAnalysis = "DTE"
        else:
            self.measurementAnalysis = "DTEHF"
        
        ############################################
        # DJWAT REVISIT
        #         next $measurementAnalysis
        return (super().createResult(self,measurementAnalysis))
    
        revisit = 1
 
    def setFilterType ( self,mtype ):
        
        super().selectSlot (self.timeMeasurement)
        self.filterType = mtype
        if self.filterType == "LF":
            super().enableMeasurement ("DTE")
        elif filterType == "HF":
            super().enableMeasurement ("DTEHF")
        else:
            error (" Error: Incorrect filter type: %s, Possible filter types are $filterTypesList " % mtype)
        
    
    
    def getFilterType (self):
        
        return (self.filterType)
    
    
    def setLimitEnable ( self,value ):
        
        self.errorCheckLimitConfigurationAvailability()
        if self.filterType == "LF" :
            ############################################
            # DJWAT REVISIT
            #            next "DTE" $value
            revisit = 1
            super().setLimitEnable("DTE", value)
        else:
            ############################################
            # DJWAT REVISIT
            #           next "DTEHF" $value
            super().setLimitEnable("DTEHF", value)
            revisit = 1
           
    
    
    def getLimitEnable (self):
        
        self.errorCheckLimitConfigurationAvailability()
        if self.filterType == "LF":
            ############################################
            # DJWAT REVISIT
            #            next "DTE"
            revisit = 1
            limitEnable = super().getLimitEnable("DTE")
        else:
            ############################################
            # DJWAT REVISIT
            #           next "DTEHF" 
            revisit = 1
            limitEnable = super().getLimitEnable("DTEHF")
        return (limitEnable)
   
    
    
    def setLimitValue ( self,limitValue ):
        
        self.errorCheckLimitConfigurationAvailability()
        if self.filterType == "LF":
        ############################################
         # DJWAT REVISIT
        #            next "DTE" $limitValue
            revisit = 1
            super().setLimitValue("DTE", limitValue)
   
        else:
            ############################################
            # DJWAT REVISIT
            #            next "DTEHF" $limitValue
    
            revisit = 1
            super().setLimitValue("DTEHF", limitValue)

    def getLimitValue (self):
        
        self.errorCheckLimitConfigurationAvailability()
        if self.filterType == "LF" :
        ############################################
        # DJWAT REVISIT
        #            next "DTE"

            revisit = 1
            limitValue = super().getLimitValue("DTE")
        else:
        ############################################
        # DJWAT REVISIT
        #           next "DTEHF" 
            revisit = 1
            limitValue = super().getLimitValue("DTE")
        
        returrn (limitValue)   

    # =================================================================================================

class DTEMTIELF_TDEVLFMeasurementAnalysis (TimeErrorMeasurementAnalysis):
    global  paragonObject 
    global  timeMeasurement
    global masksListMTIE 
    global masksListTDEV
     
    
    global filterType
    
    def __init__ (self, paragonObject1, timeMeasurement1 ):
    ############################################
    # DJWAT REVISIT
    #        next $paragonObject1
        self.paragonObject = paragonObject1
        self.timeMeasurement  = timeMeasurement1
        super().__init__(paragonObject1)
    #        set masksListMTIE { "G.8261.1" "G.8263" "G.8271.1 Network Limit" "G.8273.2 dTE Gen Const Temp"\
    #        "G.8273.2 dTE Gen Var Temp" "GR.1244 Wander Generation" "G.811 Wander Generation" \
    #        "G.813 Wander Generation SEC Op1" "G.813 Wander Generation SEC Op1 +Temp" \
    #        "G.813 Wander Generation SEC Op2" "G.813 Wander Transient SEC Opt2" "G.823 E1 Traffic Interface 2048" \
    #        "G.823 E1 PDH Sync Interface" "G.823 E1 PRC Interface" "G.823 E1 SEC Interface" "G.823 E1 SSU Interface"\
    #        "G.824 Traffic Interface 1544" "G.824 T1 PRC Interface" "G.8261 Wander Limits EEC Op1"\
    #        "G.8262 Wander Generation EEC Op1" "G.8262 Wander Generation EEC Op1 +Temp"\
    #        "G.8262 Wander Generation EEC Op2" "G.8262 Wander Transient EEC Opt2" "G.8272 PRTC" }
        
    #        set masksListTDEV { "G.8273.2 dTE Gen Const Temp" "GR.1244 Wander Generation" "G.811 Wander Generation" \
    #        "G.813 Wander Generation SEC Op1" "G.813 Wander Generation SEC Op2" "G.813 Wander Transfer SEC Opt2"\
    #        "G.823 El PDH Sync Interface" "G.823 El PRC Interface" "G.823 El SEC Interface" "G.823 El SSU Interface"\
    #        "G.824 Traffic Interface 1544" "G.824 T1 PRC Interface" "G.8261 Wander Limits EEC Op1"\
    #        "G.8261 Wander Limits EEC Op2" "G.8262 Wander Transfer EEC Opt2" "G.8262 Wander Generation EEC Op1"\
    #        "G.8262 Wander Generation EEC Op2" "G.8272 PRTC" }
    
        masksListMTIE = [ "G.8261.1","G.8263","G.8271.1 Network Limit","G.8273.2 dTE Gen Const Temp",\
        "G.8273.2 dTE Gen Var Temp","GR.1244 Wander Generation","G.811 Wander Generation",\
        "G.813 Wander Generation SEC Op1","G.813 Wander Generation SEC Op1 +Temp",\
        "G.813 Wander Generation SEC Op2","G.813 Wander Transient SEC Opt2","G.823 E1 Traffic Interface 2048",\
        "G.823 E1 PDH Sync Interface","G.823 E1 PRC Interface","G.823 E1 SEC Interface","G.823 E1 SSU Interface",\
        "G.824 Traffic Interface 1544","G.824 T1 PRC Interface","G.8261 Wander Limits EEC Op1",\
        "G.8262 Wander Generation EEC Op1","G.8262 Wander Generation EEC Op1 +Temp",\
        "G.8262 Wander Generation EEC Op2","G.8262 Wander Transient EEC Opt2","G.8272 PRTC"]
        
        masksListTDEV = [ "G.8273.2 dTE Gen Const Temp","GR.1244 Wander Generation","G.811 Wander Generation",\
        "G.813 Wander Generation SEC Op1","G.813 Wander Generation SEC Op2","G.813 Wander Transfer SEC Opt2",\
        "G.823 El PDH Sync Interface","G.823 El PRC Interface","G.823 El SEC Interface","G.823 El SSU Interface",\
        "G.824 Traffic Interface 1544","G.824 T1 PRC Interface","G.8261 Wander Limits EEC Op1",\
        "G.8261 Wander Limits EEC Op2","G.8262 Wander Transfer EEC Opt2","G.8262 Wander Generation EEC Op1",\
        "G.8262 Wander Generation EEC Op2","G.8272 PRTC" ]
    
    #def __del__():    
    

    
    def createResult (self):
        
        if self.filterType == "MTIELF" :
            self.measurementAnalysis = "DTEMTIE"
        else:
            self.measurementAnalysis = "DTETDEV"
           
    ############################################0
    # DJWAT REVISIT
    #         next $measurementAnalysis
        revisit = 1
        return (super().createResult(self.measurementAnalysis))
    
    
    
    def setFilterType ( self,ftype ):
        
        super().selectSlot (self.timeMeasurement)
        self.filterType = ftype
        if self.filterType == "MTIELF" :
            super().enableMeasurement ("DTEMTIE")
        elif self.filterType == "TDEVLF" :
            super().enableMeasurement ("DTETDEV")
        else:
            error (" Error: Incorrect filter type: %s, Possible filter types are %s " %(ftype,self.filterTypesList))
        
    
    
    
    def getFilterType (self):
        return (self.filterType)
    
    
    
    def setMask ( self, maskType ):
        
        super().selectSlot (self.timeMeasurement)
        if self.filterType == "MTIELF" :
            mtype = "DTEMTIE"
        else:
            mtype = "DTETDEV" 
         
        
        if (self.filterType == "MTIELF" and  maskType in self.masksListMTIE)  or  (self.filterType == "TDEVLF" and maskType in self.masksListTDEV  ):
            self.paragonObject.paragonset ("Cat %s  Mask" % mtype,  str(maskType))
            #$paragonObject calculateRequiredSetTrue
        else:
            error (" Error: Incorrect Mask type: %s for %s" % (maskType,self.filterType))
        
    # =================================================================================================

class DTEMTIELF_TDEVLFMeasurementAnalysis (TimeErrorMeasurementAnalysis):
    global  paragonObject 
    global  timeMeasurement
    global masksListMTIE 
    global masksListTDEV
     
    
    global filterType
    
    def __init__ (self, paragonObject1, timeMeasurement1 ):
    ############################################
    # DJWAT REVISIT
    #        next $paragonObject1
        self.paragonObject = paragonObject1
        self.timeMeasurement  = timeMeasurement1
        super().__init__(self.paragonObject1)
    #        set masksListMTIE { "G.8261.1" "G.8263" "G.8271.1 Network Limit" "G.8273.2 dTE Gen Const Temp"\
    #        "G.8273.2 dTE Gen Var Temp" "GR.1244 Wander Generation" "G.811 Wander Generation" \
    #        "G.813 Wander Generation SEC Op1" "G.813 Wander Generation SEC Op1 +Temp" \
    #        "G.813 Wander Generation SEC Op2" "G.813 Wander Transient SEC Opt2" "G.823 E1 Traffic Interface 2048" \
    #        "G.823 E1 PDH Sync Interface" "G.823 E1 PRC Interface" "G.823 E1 SEC Interface" "G.823 E1 SSU Interface"\
    #        "G.824 Traffic Interface 1544" "G.824 T1 PRC Interface" "G.8261 Wander Limits EEC Op1"\
    #        "G.8262 Wander Generation EEC Op1" "G.8262 Wander Generation EEC Op1 +Temp"\
    #        "G.8262 Wander Generation EEC Op2" "G.8262 Wander Transient EEC Opt2" "G.8272 PRTC" }
        
    #        set masksListTDEV { "G.8273.2 dTE Gen Const Temp" "GR.1244 Wander Generation" "G.811 Wander Generation" \
    #        "G.813 Wander Generation SEC Op1" "G.813 Wander Generation SEC Op2" "G.813 Wander Transfer SEC Opt2"\
    #        "G.823 El PDH Sync Interface" "G.823 El PRC Interface" "G.823 El SEC Interface" "G.823 El SSU Interface"\
    #        "G.824 Traffic Interface 1544" "G.824 T1 PRC Interface" "G.8261 Wander Limits EEC Op1"\
    #        "G.8261 Wander Limits EEC Op2" "G.8262 Wander Transfer EEC Opt2" "G.8262 Wander Generation EEC Op1"\
    #        "G.8262 Wander Generation EEC Op2" "G.8272 PRTC" }
    
        masksListMTIE = [ "G.8261.1","G.8263","G.8271.1 Network Limit","G.8273.2 dTE Gen Const Temp",\
        "G.8273.2 dTE Gen Var Temp","GR.1244 Wander Generation","G.811 Wander Generation",\
        "G.813 Wander Generation SEC Op1","G.813 Wander Generation SEC Op1 +Temp",\
        "G.813 Wander Generation SEC Op2","G.813 Wander Transient SEC Opt2","G.823 E1 Traffic Interface 2048",\
        "G.823 E1 PDH Sync Interface","G.823 E1 PRC Interface","G.823 E1 SEC Interface","G.823 E1 SSU Interface",\
        "G.824 Traffic Interface 1544","G.824 T1 PRC Interface","G.8261 Wander Limits EEC Op1",\
        "G.8262 Wander Generation EEC Op1","G.8262 Wander Generation EEC Op1 +Temp",\
        "G.8262 Wander Generation EEC Op2","G.8262 Wander Transient EEC Opt2","G.8272 PRTC"]
        
        masksListTDEV = [ "G.8273.2 dTE Gen Const Temp","GR.1244 Wander Generation","G.811 Wander Generation",\
        "G.813 Wander Generation SEC Op1","G.813 Wander Generation SEC Op2","G.813 Wander Transfer SEC Opt2",\
        "G.823 El PDH Sync Interface","G.823 El PRC Interface","G.823 El SEC Interface","G.823 El SSU Interface",\
        "G.824 Traffic Interface 1544","G.824 T1 PRC Interface","G.8261 Wander Limits EEC Op1",\
        "G.8261 Wander Limits EEC Op2","G.8262 Wander Transfer EEC Opt2","G.8262 Wander Generation EEC Op1",\
        "G.8262 Wander Generation EEC Op2","G.8272 PRTC" ]
    
    #def __del__():    
    

    
    def createResult (self):
        
        if self.filterType == "MTIELF" :
            self.measurementAnalysis = "DTEMTIE"
        else:
            self.measurementAnalysis = "DTETDEV"
           
    ############################################0
    # DJWAT REVISIT
    #         next $measurementAnalysis

        return (super().createResult(self.measurementAnalysis))
        revisit = 1
    
    
    
    def setFilterType ( self,ftype ):
        
        super().selectSlot (self.timeMeasurement)
        self.filterType = ftype
        if self.filterType == "MTIELF" :
            super().enableMeasurement ("DTEMTIE")
        elif self.filterType == "TDEVLF" :
            super().enableMeasurement ("DTETDEV")
        else:
            error (" Error: Incorrect filter type: %s, Possible filter types are %s " %(ftype,self.filterTypesList))
        
    
    
    
    def getFilterType (self):
        return (self.filterType)
    
    
    
    def setMask ( self,maskType ):
        
        super().selectSlot (self.timeMeasurement)
        if self.filterType == "MTIELF" :
            mtype = "DTEMTIE"
        else:
            mtype = "DTETDEV" 
         
        
        if (self.filterType == "MTIELF" and  maskType in self.masksListMTIE)  or  (self.filterType == "TDEVLF" and maskType in self.masksListTDEV  ):
            self.paragonObject.paragonset ("Cat %s  Mask" % mtype,  src(maskType))
            #$paragonObject calculateRequiredSetTrue
        else:
            error (" Error: Incorrect Mask type: %s for %s" % (maskType,self.filterType))
        
        
    
    

    def getMask (self):
        
        super().selectSlot (self.timeMeasurement)
        if self.filterType == "MTIELF":
            mtype = "DTEMTIE"
        else:
            mtype = "DTETDEV" 
        
        
        if self.paragonObject.paragonget ("Cat %s Mask" % mtype ): 
            return ("no mask ")
        else:
            return (self.paragonObject.paragonget ("Cat %s Mask" % mtype ))
  

  
