import time

class Result:

    def __init__ (self,paragonObject1,measurementAnalysis1,timeMeasurement1):
        
        self.paragonObject = paragonObject1
        self.timeMeasurement = timeMeasurement1
        self.measurementAnalysis  = measurementAnalysis1
        self.paragonObject.calculateRequiredSetTrue()
    
    
    #def __del__ ()
    
    def setup ( self,timeMeasurement ):
        self.paragonObject.paragonset ( "Cat SelectSlot",  timeMeasurement)
        #$paragonObject calculate
        self.paragonObject.calculateSpecified( self.timeMeasurement , self.measurementAnalysis)
    
    
    
    def getMean (self):
        self.setup (self.timeMeasurement)

        if  self.measurementAnalysis == "ATE":
             error ( "Error: mean result ( getMean ) is not accessible for this measurement analysis ")
        else:
            return ( self.paragonObject.paragonget ("Cat %s Mean" % self.measurementAnalysis) )
        
    
    
    # cTe result is only avaliable for ATE
    def getCTe(self):       
        self.setup (self.timeMeasurement)

        
        if self.measurementAnalysis != "ATE":
             error ("Error: cTe result ( getCTe ) is not accessible for this measurement analysis, only for ATE ")
        else:
            return (self.paragonObject.paragonget("Cat cTe %s" % self.measurementAnalysis))
        
    
    
    def getMin (self):
        self.setup( self.timeMeasurement)
        
        return (self.paragonObject.paragonget("Cat %s Min" % self.measurementAnalysis)) 
    
    
    def getMax (self): 
        self.setup (self.timeMeasurement)
        
        return (self.paragonObject.paragonget ("Cat %s Max" % self.measurementAnalysis) )
    
    
    def getMax_Min (self):
        self.setup (self.timeMeasurement)
        
        return ( self.paragonObject.paragonget ("Cat %s Range" % self.measurementAnalysis ))
    
    
    
    def getMaskResult (self):
        self.setup (self.timeMeasurement)
        
         
        # mask result is only avaliable for MTIE and TDEV Dynamic Time Error - thus the error is thrown when measurementAnalysis is none of these
        if self.measurementAnalysis != "DTEMTIE" and self.measurementAnalysis != "DTETDEV":
            error (" Error: Mask result ( getMaskResult ) is not accessible for this measurement analysis: %s %s , only for DTEMTIE and DTETDEV" % (self.measurementAnalysis,  self.timeMeasurement ))     
        else:
            return  (self.paragonObject.paragonget ( "Cat %s  MaskResult" % self.measurementAnalysis )) 
        
    
    
    def getLimitResult(self):
        self.setup (self.timeMeasurement)
        
        
        # limit result is only avaliable for ATE, TE, 2Way DTE LF and 2Way DTE HF - thus the error is thrown when measurementAnalysis is none of these
        if self.measurementAnalysis != "TE" and self.measurementAnalysis != "ATE" and not ( (self.measurementAnalysis == "DTE" or self.measurementAnalysis == "DTEHF") and self.timeMeasurement == "2Way" ):   
            error (" Error: Limit result ( getLimitResult ) is not accessible for this measurement: %s %s , only for TE, ATE, DTE 2Way or DTEHF 2Way " % (self.measurementAnalysis , self.timeMeasurement) )    
        else:
            return (par1.paragonget( "Cat %s MaskResult" % measurementAnalysis)) 
        
    




# =================================================================================================


class ResultSet1 (Result):

    def __init__ (self,  paragonObject1,  measurementAnalysis1, timeMeasurement1):
    
        self.paragonObject = paragonObject1
        self.measurementAnalysis = measurementAnalysis1
        self.timeMeasurement = timeMeasurement1
        super().__init__(self.paragonObject, self.measurementAnalysis ,self.timeMeasurement)

    #def __del__ ():
    
    
    def getFwdMessages():
        super().setup(self.timeMeasurement)

        return ( self.paragonObject.paragonget(" Cat %s FwdMessages" % self.measurementAnalysis ))
    
    
    def getRevMessages (self):
        super().setup (self.timeMeasurement)
        return (self.paragonObject.paragonget ("Cat %s RevMessages" % self.measurementAnalysis))
    
    
    def getForwardRate (self):
        super().setup (self.timeMeasurement)
        return ( self.paragonObject.paragonget ( "Cat %s FwdRate" % self.measurementAnalysis ))
    
    
    def getReverseRate (self):

        super.setup (self.timeMeasurement)
        return (self.paragonObject.paragonget ("Cat %s  RevRate" % self.measurementAnalysis ))
    


# =================================================================================================


class ResultSet2 (Result): 

    def __init__ (self,  paragonObject1,  measurementAnalysis1, timeMeasurement1):
  
        self.paragonObject = paragonObject1
        self.measurementAnalysis = measurementAnalysis1
        self.timeMeasurement = timeMeasurement1
 
        ##################
        ##  DJWAT REVISIT
        ####################
        #  constructor { paragonObject1 measurementAnalysis1 timeMeasurement1 } {
        #next $paragonObject1 $measurementAnalysis1 $timeMeasurement1 
        super().__init__(self.paragonObject,self.measurementAnalysis, self.timeMeasurement)
    
    
    #def __del__ ():      
    
    
    def getMessages (self):
        ##################
        ##  DJWAT REVISIT
        ####################
        super().setup (self.timeMeasurement)
        return ( self.paragonObject.paragonget ("Cat %s  Messages" % self.measurementAnalysis ))
    
    
    def getRate (self):        
        
        ##################
        ##  DJWAT REVISIT
        ####################
        super().setup (self.timeMeasurement)
        return (self.paragonObject.paragonget(" Cat %s Rate" % self.measurementAnalysis))
    


# =================================================================================================


